#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: helpBrowser.py
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0

from qt import *
import sys

class helpWindow(QDialog):
	
	def __init__(self,*args):
        	apply(QDialog.__init__,(self,) + args)
		self.setCaption(_(u'lrcShow-II文档查看器'))
		self.setIcon(QPixmap('../scripts/lrcShow-II/icon/help.png'))
		self.label=QLabel(self)
		self.label.setText(_(u'请选择相关条目：'))
		self.contentBro=browserView(self)
		self.itemBro=itemListView(self)
		MainWindowLayout=QVBoxLayout(self,0,6,"MainWindowLayout")
		layout1=QHBoxLayout(None,2,6,"layout1")
		layout1.addWidget(self.label)
		layout1.addWidget(self.itemBro)
		layout2=QVBoxLayout(None,2,6,"layout1")
		layout2.addLayout(layout1)
		layout2.addWidget(self.contentBro)
		MainWindowLayout.addLayout(layout2)
		self.setFixedSize(500,300)
		self.connect(self.itemBro,SIGNAL("activated(int)"),self.moveTo)
		
	def moveTo(self,f):
		self.contentBro.clear()
		if(f==0):
			fileName='../scripts/lrcShow-II/document/document-zh.html'
		elif(f==1):
			fileName='../scripts/lrcShow-II/document/document-en.html'
		elif(f==2):
			fileName='../scripts/lrcShow-II/document/COPYING'
		file=open(fileName)
		a=file.read()
		file.close()
		self.contentBro.setText(a.decode('utf8'))

class itemListView(QComboBox):
	
	def __init__(self,*args):
        	apply(QComboBox.__init__,(self,) + args)
		a=[_(u'帮助文档'),_(u'帮助文档英文版'),_(u'授权协议')]
		for i in range(len(a)):
			self.insertItem(a[i],i)
		

class browserView(QTextBrowser):
	
	def __init__(self,*args):
        	apply(QTextBrowser.__init__,(self,) + args)
		self.setWrapPolicy(QTextEdit.AtWordBoundary)
		self.setHScrollBarMode(QTextEdit.AlwaysOff)
		file=open('../scripts/lrcShow-II/document/document-zh.html')
		a=file.read()
		file.close()
		self.setText(a.decode('utf8'))
	
def main(args):
	app=QApplication(args)
	win=helpWindow()
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
	app.exec_loop()

if(__name__=="__main__"):
	main(sys.argv)