#!/usr/bin/env python
#-*- coding: UTF-8 -*-
# Filename: lrcShow-II.py
# Version:0.7.0
# Author: Xu Jia (Sanfanling)   E-mail:xujia19@sohu.com
# Lisence: GPL-2.0
#

import os,sys,commands,gettext,pickle
from socket import setdefaulttimeout

setdefaulttimeout(15)

c='''[option]
lrcpath=%s,
savelrcpath=%s
download=no
linenumber=3
backroundcolor=57,64,98
fontcolor=255,255,255
highlightcolor=180,200,255
fonttype=serif
fontsize=9
proxy=no
encoder=utf8
searchengine=ttPlayer
nolrc=normal
includecancel=no
autoinsert=no
titlebarinfo=no
completetag=no''' %(os.getenv('HOME'),os.getenv('HOME'))

def mainQt4(args):
	app=QApplication(args)
	win=mainBox()
	thread=myThread(win,app)
	thread.start()
	win.show()
	sys.exit(app.exec_())

def mainQt3(args):
	app=QApplication(args)
	win=mainBox()
	thread=myThread(win,app)
	thread.start()
	win.show()
	app.connect(app, SIGNAL("lastWindowClosed()"),app, SLOT("quit()"))
	app.exec_loop()

if __name__=="__main__":
	try:
		gettext.translation('lrcShow-II','../scripts/lrcShow-II/locale').install(unicode=True)
	except IOError:
		gettext.translation('lrcShow-II','../scripts/lrcShow-II/locale',languages=['en_US']).install(unicode=True)
	
	if(os.path.exists('lrcShow-II.conf')):
		pass
	else:
		file=open('lrcShow-II.conf','w')
		file.write(c)
		file.close()
	if(os.path.exists('lrcShow-II.db')):
		pass
	else:
		mydb=open('lrcShow-II.db','w')
		pickler=pickle.Pickler(mydb,True)
		pickler.dump({})
		mydb.close()
	
	try:
		from qt import *
	except ImportError:
		try:
			from PyQt4.QtCore import *
			from PyQt4.QtGui import *
		except ImportError:
			os.system('dcop amarok playlist popupMessage "You should install pyqt3 or pyqt4 in your system first"')
			sys.exit()
		else:
			from mainGuiQt4 import *
			mainQt4(sys.argv)
	else:
		from mainGuiQt3 import *
		mainQt3(sys.argv)
